MATRICES
========

In cases when (more or less) the same test procedure needs to be performd on a
group of equivalent and independent objects, it might be desirable to generate
collective form, usable for testing in parallel.



Example
-------


Source STM defines actions that are only valid under certain circumstances.

    Name: Release Client - parallel
    Description: Example of parallel procedures
    Vars: arch=amd64,x86
    
    # Parallel showcase #

    ## Install ##
    1. Create a folder with CJK characters
    2. Install Product
    3. Open Start menu -> ACME
    4. Check links
       * Help.lnk
       * Product.lnk
       * Product (64-bit).lnk {arch==amd64}
    5. Restart


The above can result in two STS:

    Stm: /release/rc.stm
    Stm Revision: 123
    Params: arch=amd64
    
    # Parallel showcase #

    ## Install ##
    1. Create a folder with CJK characters
    2. Install Product
    3. Open Start menu -> ACME
    4. Check links
       * Help.lnk
       * Product.lnk
       * Product (64-bit).lnk
    5. Restart


    Stm: /release/rc.stm
    Stm Revision: 123
    Params: arch=x86
    
    # Parallel showcase #

    ## Install ##
    1. Create a folder with CJK characters
    2. Install Product
    3. Open Start menu -> ACME
    4. Check links
       * Help.lnk
       * Product.lnk
    5. Restart


Or one "double" STS -- notice `Params:` header:

    Stm: /release/rc.stm
    Stm Revision: 123
    Params: arch=x86+amd64
    
    # Parallel showcase #

    ## Install ##
    1. Create a folder with CJK characters
    2. Install Product
    3. Open Start menu -> ACME
    4. Check links
       * Help.lnk
       * Product.lnk
       * Product (64-bit).lnk {arch==amd64}
    5. Restart


The point is that the double STM can be rendered for parallel processing:

    +-------------------------------------------------------------------+
    | PARALLEL SHOWCASE                                                 |
    +-------------------------------------------------------------------+
    |                                                                   |
    |  ## Install ##                              x86         amd64     |
    | 1. Create a folder with CJK characters    [ Passed  ] [ Passed  ] |
    | 2. Install Product                        [ Passed  ] [ Passed  ] |
    | 3. Open Start menu -> ACME                [ Passed  ] [ Passed  ] |
    | 4. Check links                            [ Passed  ] [ Passed  ] |
    |    * Help.lnk                             [ Passed  ] [ Passed  ] |
    |    * Product.lnk                          [ Passed  ] [ Failed  ] |
    |    * Product (64-bit).lnk                             [ Passed  ] |
    | 5. Restart                                [ Passed  ] [ Passed  ] |
    |                                                                   |
    +-------------------------------------------------------------------+

