#!/usr/bin/perl
use strict;
use warnings;
use Test::More;

use lib 'lib';
use helper;

BEGIN { use_ok( 'SugarTrail::Repo' ); }
require_ok( 'SugarTrail::Repo' );

my $repo = SugarTrail::Repo->new(root => './t/data/strepo', vcs => 'git');
ok($repo,           "repo is true");

my $stm = $repo->load_stm(stm=>'/release/rc.stm');
ok($stm,            "master is true");

my ($hc,$bc) = $stm->parse();
is($hc, 6,  "parse() reported 6 headers");
is($bc, 13, "parse() reported 13 non-header lines");

my $sts = $stm->generate_slave({ proto => "imap", os => "wxx" });
ok($sts,            "slave is true");

&helper::dmup(master=>$stm);
&helper::dmup(slave=>$sts);

done_testing();
