#!/usr/bin/perl
use strict;
use warnings;
use Test::More;

use lib 'lib';
use helper;
use SugarTrail::Repo;

my $repo = SugarTrail::Repo->new(root => './t/data/strepo', vcs => 'git');

my $data;
$data->{mp} = $repo->load_stm(stm=>'/selftest/positive/multiple_parameters.stm');
$data->{mw} = $repo->load_stm(stm=>'/selftest/negative/multiple_warnings.stm');

ok($data->{mp}, "multiple_parameters: master is true");
ok($data->{mw}, "multiple_warnings: master is true");

my $s1 = $data->{mp}->generate_slave({ proto => "imap", os => "w7a" });
ok($s1,             "multiple_parameters: slave is true");

my $s2 = $data->{mw}->generate_slave({ os => "w7a", arch => "amd64" });
ok($s2,             "multiple_warnings: slave is true");

&helper::dmup(s1=>\$s1);
&helper::dmup(s2=>\$s2);

done_testing();
